mode 1,8
cls

nroid = 100

' index contains
'   0   animation step number 0-30
'   1   animation increment
'   2   x location
'   3   y location
'   4   x increment
'   5   y increment
'   6   asteroid mirroring 1=left/right  2=up/down (3=both)
'   7   sprite family - 0 or 4 because the sprite sheet has 2
dim aloc(nroid,7)

page write 2
cls
load png "asteroid-sprite-440x464.png"
page write 1
cls 'rgb(gray)
'box 175,225,320,200,0,0,0

for i = 0 to nroid
  aloc(i,0) = int(rnd * 31)
  aloc(i,1) = rnd * 1.5 - 1
  aloc(i,1) = aloc(i,1) - (aloc(i,1) < .25) / 2 ' no rotation near 0
  aloc(i,2) = int(rnd * 280) + 175 ' x posn
  aloc(i,3) = int(rnd * 180) + 225 ' y posn
  aloc(i,4) = rnd * 4 - 2          ' x vel
  aloc(i,4) = aloc(i,4) + (aloc(i,4) > -.5)  ' no velocity near 0
  aloc(i,5) = rnd * 4 - 2          ' y vel
  aloc(i,5) = aloc(i,5) + (aloc(i,5) > -.5)
  aloc(i,6) = int(rnd * 4) + 4     ' sprite draw orientation
  aloc(i,7) = int(rnd * 2) * 4     ' sprite family
next i

i = 0
do
  page write 1
  cls

  for i = 0 to nroid
    blit (aloc(i,0) MOD 8)*55,(aloc(i,7) + aloc(i,0) \ 8)*58,aloc(i,2),aloc(i,3),55,58,2,aloc(i,6)

    ' rotate each rock
    aloc(i,0) = aloc(i,0) + aloc(i,1)
    if aloc(i,0) > 30 then
      aloc(i,0) = aloc(i,0) - 30
    elseif aloc(i,0) < 0 then
      aloc(i,0) = aloc(i,0) + 30
    endif

    ' adjust rock x position
    aloc(i,2) = aloc(i,2) + aloc(i,4)
    if aloc(i,2) > 800 then '560 then
      aloc(i,2) = aloc(i,2) - 850 '370
    elseif aloc(i,2) < -50 then '190 then
      aloc(i,2) = aloc(i,2) + 850 '370
    endif

    ' adjust rock y position
    aloc(i,3) = aloc(i,3) + aloc(i,5)
    if aloc(i,3) > 600 then '400 then
      aloc(i,3) = aloc(i,3) - 650 '250
    elseif aloc(i,3) < -50 then '150 then
      aloc(i,3) = aloc(i,3) + 650 '250
    endif

  next i

'  box MM.HRES/2-260,MM.VRES/2-200,520,400,100,rgb(gray)

  page copy 1,0,B
'  pause 5
loop